import { base, zh_CN, en, Faker } from '@faker-js/faker';
import { ModuleMetadata } from '@nestjs/common';
import { isFunction } from 'lodash';

export const getEntities = (modules: ModuleMetadata['imports'] = []) =>
    modules
        .map((m) => ('entities' in m && isFunction(m.entities) ? m.entities() : []))
        .reduce((o, n) => [...o, ...n], []);

const faker = new Faker({
    locale: [zh_CN, en, base],
});
export const getFaker = () => faker;
